/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+ 8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002-2004
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation  assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	timer_user.c
**  Abstract :	This file implements device driver for the timer module.
**  APIlib:	NEC78K0SKX1H.lib E1.46a [13 May 2005]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/

#pragma sfr
#pragma interrupt  INTTM000 MD_INTTM000
/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "timer.h"


/*
*******************************************************************************
**  MacroDefine
*******************************************************************************
*/
/*
**-----------------------------------------------------------------------------
**
**  Abstract:
**	This function is TM00 INTTM000 interrupt service routine.
**	
**  Parameters:
**	None
**
**  Returns:
**	None
**
**-----------------------------------------------------------------------------
*/
extern	int		moji_p;
extern	int		moji_set;

__interrupt void MD_INTTM000( )
{

	/* TODO */
	if(moji_p<63){
		moji_p++;
	}
	else{
		moji_p=0;
		switch(moji_set){
			case 0:moji_set=1;break;
			case 1:moji_set=2;break;
			case 2:moji_set=0;break;
			case 3:moji_set=4;break;
			case 4:moji_set=5;break;
			case 5:moji_set=3;break;
		}
	}

}
