/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+ 8-Bit Single-Chip Microcontrollers.
**
**  Copyright(C) NEC Electronics Corporation 2002-2004
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	main.c
**  Abstract :	This file implements main function.
**  APIlib :	NEC78K0SKX1H.lib E1.46a [13 May 2005]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/
/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "system.h"
#include "port.h"
#include "timer.h"
#include "watchdogtimer.h"
/*
*******************************************************************************
**  MacroDefine
*******************************************************************************
*/
/*
**---------------------------------------------------------------------------
**
**  Abstract:
**	This function implements main function.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**---------------------------------------------------------------------------
*/

char	disp_data[8]=
			{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff};

char 	moji_data[63];

int		moji_p;
int		moji_set;

void	data_set(int set)
{
	if(set==0){

		moji_data[0]=0x00;moji_data[1]=0x00;moji_data[2]=0x00;moji_data[3]=0x00;
		moji_data[4]=0x00;moji_data[5]=0x00;moji_data[6]=0x00;moji_data[7]=0x00;
		moji_data[8]=0x00;
		moji_data[9]=0xff;moji_data[10]=0xff;moji_data[11]=0x0e;moji_data[12]=0x1c;
		moji_data[13]=0x38;moji_data[14]=0x70;moji_data[15]=0xff;moji_data[16]=0xff;
		moji_data[17]=0x00;
		moji_data[18]=0x7e;moji_data[19]=0xff;moji_data[20]=0xc3;moji_data[21]=0x81;
		moji_data[22]=0x81;moji_data[23]=0xc3;moji_data[24]=0xff;moji_data[25]=0x7e;
		moji_data[26]=0x00;
		moji_data[27]=0xff;moji_data[28]=0xff;moji_data[29]=0x0e;moji_data[30]=0x1c;
		moji_data[31]=0x38;moji_data[32]=0x70;moji_data[33]=0xff;moji_data[34]=0xff;
		moji_data[35]=0x00;
		moji_data[36]=0x7e;moji_data[37]=0xff;moji_data[38]=0xc3;moji_data[39]=0x81;
		moji_data[40]=0x81;moji_data[41]=0xc3;moji_data[42]=0xe7;moji_data[43]=0x66;
		moji_data[44]=0x00;
		moji_data[45]=0xff;moji_data[46]=0xff;moji_data[47]=0x18;moji_data[48]=0x18;
		moji_data[49]=0x18;moji_data[50]=0x18;moji_data[51]=0xff;moji_data[52]=0xff;
		moji_data[53]=0x00;
		moji_data[54]=0xfc;moji_data[55]=0xfe;moji_data[56]=0x33;moji_data[57]=0x33;
		moji_data[58]=0x33;moji_data[59]=0x33;moji_data[60]=0xfe;moji_data[61]=0xfc;
		moji_data[62]=0x00;
	}
	if(set==1){
		moji_data[0]=0xff;moji_data[1]=0xff;moji_data[2]=0x0e;moji_data[3]=0x1c;
		moji_data[4]=0x38;moji_data[5]=0x70;moji_data[6]=0xff;moji_data[7]=0xff;
		moji_data[8]=0x00;
		moji_data[9]=0x46;moji_data[10]=0xcf;moji_data[11]=0x9f;moji_data[12]=0x99;
		moji_data[13]=0x99;moji_data[14]=0xf9;moji_data[15]=0xf3;moji_data[16]=0x62;
		moji_data[17]=0x00;
		moji_data[18]=0x7e;moji_data[19]=0xff;moji_data[20]=0xc3;moji_data[21]=0x81;
		moji_data[22]=0x81;moji_data[23]=0xc3;moji_data[24]=0xff;moji_data[25]=0x7e;
		moji_data[26]=0x00;
		moji_data[27]=0xff;moji_data[28]=0xff;moji_data[29]=0x19;moji_data[30]=0x19;
		moji_data[31]=0x19;moji_data[32]=0x19;moji_data[33]=0x19;moji_data[34]=0x01;
		moji_data[35]=0x00;
		moji_data[36]=0x01;moji_data[37]=0x01;moji_data[38]=0x01;moji_data[39]=0xff;
		moji_data[40]=0xff;moji_data[41]=0x01;moji_data[42]=0x01;moji_data[43]=0x01;
		moji_data[44]=0x00;
		moji_data[45]=0x00;moji_data[46]=0x18;moji_data[47]=0x18;moji_data[48]=0x18;
		moji_data[49]=0x18;moji_data[50]=0x18;moji_data[51]=0x18;moji_data[52]=0x00;
		moji_data[53]=0x00;
		moji_data[54]=0xe2;moji_data[55]=0xf3;moji_data[56]=0xbb;moji_data[57]=0x99;
		moji_data[58]=0x99;moji_data[59]=0x9f;;moji_data[60]=0x8f;moji_data[61]=0x86;
		moji_data[62]=0x00;
	}
	if(set==2){
		moji_data[0]=0x7e;moji_data[1]=0xff;moji_data[2]=0xc3;moji_data[3]=0x81;
		moji_data[4]=0x81;moji_data[5]=0xc3;moji_data[6]=0xff;moji_data[7]=0x7e;
		moji_data[8]=0x00;
		moji_data[9]=0x7e;moji_data[10]=0xff;moji_data[11]=0xc3;moji_data[12]=0x81;
		moji_data[13]=0x81;moji_data[14]=0xc3;moji_data[15]=0xff;moji_data[16]=0x7e;
		moji_data[17]=0x00;
		moji_data[18]=0x66;moji_data[19]=0xff;moji_data[20]=0xff;moji_data[21]=0x99;
		moji_data[22]=0x99;moji_data[23]=0xff;moji_data[24]=0xff;moji_data[25]=0x66;
		moji_data[26]=0x00;
		moji_data[27]=0x00;moji_data[28]=0x18;moji_data[29]=0x18;moji_data[30]=0x18;
		moji_data[31]=0x18;moji_data[32]=0x18;moji_data[33]=0x18;moji_data[34]=0x00;
		moji_data[35]=0x00;
		moji_data[36]=0x41;moji_data[37]=0xc1;moji_data[38]=0x81;moji_data[39]=0x81;
		moji_data[40]=0xc1;moji_data[41]=0xff;moji_data[42]=0x7f;moji_data[43]=0x01;
		moji_data[44]=0x00;
		moji_data[45]=0x7f;moji_data[46]=0xff;moji_data[47]=0xc0;moji_data[48]=0x80;
		moji_data[49]=0x80;moji_data[50]=0xc0;moji_data[51]=0xff;moji_data[52]=0x7f;
		moji_data[53]=0x00;
		moji_data[54]=0xff;moji_data[55]=0xff;moji_data[56]=0x80;moji_data[57]=0x80;
		moji_data[58]=0x80;moji_data[59]=0x80;;moji_data[60]=0x80;moji_data[61]=0x80;
		moji_data[62]=0x00;
	}
	if(set==3){
		moji_data[0]=0x00;moji_data[1]=0x00;moji_data[2]=0x00;moji_data[3]=0x00;
		moji_data[4]=0x00;moji_data[5]=0x00;moji_data[6]=0x00;moji_data[7]=0x00;
		moji_data[8]=0x00;
		moji_data[9]=0x7e;moji_data[10]=0xff;moji_data[11]=0xc3;moji_data[12]=0x81;
		moji_data[13]=0x81;moji_data[14]=0xc3;moji_data[15]=0xff;moji_data[16]=0x7e;
		moji_data[17]=0x00;
		moji_data[18]=0xff;moji_data[19]=0xff;moji_data[20]=0x19;moji_data[21]=0x19;
		moji_data[22]=0x19;moji_data[23]=0x19;moji_data[24]=0x0f;moji_data[25]=0x06;
		moji_data[26]=0x00;
		moji_data[27]=0xff;moji_data[28]=0xff;moji_data[29]=0x99;moji_data[30]=0x99;
		moji_data[31]=0x99;moji_data[32]=0x99;moji_data[33]=0x99;moji_data[34]=0x81;
		moji_data[35]=0x00;
		moji_data[36]=0xff;moji_data[37]=0xff;moji_data[38]=0x0e;moji_data[39]=0x1c;
		moji_data[40]=0x38;moji_data[41]=0x70;moji_data[42]=0xff;moji_data[43]=0xff;
		moji_data[44]=0x00;
		moji_data[45]=0x00;moji_data[46]=0x82;moji_data[47]=0x82;moji_data[48]=0xff;
		moji_data[49]=0xff;moji_data[50]=0x80;moji_data[51]=0x80;moji_data[52]=0x00;
		moji_data[53]=0x00;
		moji_data[54]=0x7e;moji_data[55]=0xff;moji_data[56]=0xc3;moji_data[57]=0x81;
		moji_data[58]=0x81;moji_data[59]=0xc3;moji_data[60]=0xff;moji_data[61]=0x7e;
		moji_data[62]=0x00;
	}
	if(set==4){
		moji_data[0]=0x00;moji_data[1]=0x00;moji_data[2]=0x00;moji_data[3]=0x66;
		moji_data[4]=0x66;moji_data[5]=0x00;moji_data[6]=0x00;moji_data[7]=0x00;
		moji_data[8]=0x00;
		moji_data[9]=0x7e;moji_data[10]=0xff;moji_data[11]=0xc3;moji_data[12]=0x81;
		moji_data[13]=0x81;moji_data[14]=0xc3;moji_data[15]=0xff;moji_data[16]=0x7e;
		moji_data[17]=0x00;
		moji_data[18]=0x7e;moji_data[19]=0xff;moji_data[20]=0xc3;moji_data[21]=0x81;
		moji_data[22]=0x81;moji_data[23]=0xc3;moji_data[24]=0xff;moji_data[25]=0x7e;
		moji_data[26]=0x00;
		moji_data[27]=0x00;moji_data[28]=0x18;moji_data[29]=0x18;moji_data[30]=0x18;
		moji_data[31]=0x18;moji_data[32]=0x18;moji_data[33]=0x18;moji_data[34]=0x00;
		moji_data[35]=0x00;
		moji_data[36]=0x7e;moji_data[37]=0xff;moji_data[38]=0xc3;moji_data[39]=0x81;
		moji_data[40]=0x81;moji_data[41]=0xc3;moji_data[42]=0xe7;moji_data[43]=0x66;
		moji_data[44]=0x00;
		moji_data[45]=0xff;moji_data[46]=0xff;moji_data[47]=0x80;moji_data[48]=0x80;
		moji_data[49]=0x80;moji_data[50]=0x80;moji_data[51]=0x80;moji_data[52]=0x80;
		moji_data[53]=0x00;
		moji_data[54]=0x7e;moji_data[55]=0xff;moji_data[56]=0xc3;moji_data[57]=0x81;
		moji_data[58]=0x81;moji_data[59]=0xc3;moji_data[60]=0xff;moji_data[61]=0x7e;
		moji_data[62]=0x00;
	}
	if(set==5){
		moji_data[0]=0x46;moji_data[1]=0xcf;moji_data[2]=0x9f;moji_data[3]=0x99;
		moji_data[4]=0x99;moji_data[5]=0xf9;moji_data[6]=0xf3;moji_data[7]=0x62;
		moji_data[8]=0x00;
		moji_data[9]=0xff;moji_data[10]=0xff;moji_data[11]=0x99;moji_data[12]=0x99;
		moji_data[13]=0x99;moji_data[14]=0x99;moji_data[15]=0x99;moji_data[16]=0x81;
		moji_data[17]=0x00;
		moji_data[18]=0xe2;moji_data[19]=0xf3;moji_data[20]=0xbb;moji_data[21]=0x99;
		moji_data[22]=0x99;moji_data[23]=0x9f;moji_data[24]=0x8f;moji_data[25]=0x86;
		moji_data[26]=0x00;
		moji_data[27]=0x7e;moji_data[28]=0xff;moji_data[29]=0xdb;moji_data[30]=0x99;
		moji_data[31]=0x99;moji_data[32]=0xdb;moji_data[33]=0xf3;moji_data[34]=0x62;
		moji_data[35]=0x00;
		moji_data[36]=0x00;moji_data[37]=0x00;moji_data[38]=0x00;moji_data[39]=0x66;
		moji_data[40]=0x66;moji_data[41]=0x00;moji_data[42]=0x00;moji_data[43]=0x00;
		moji_data[44]=0x00;
		moji_data[45]=0x42;moji_data[46]=0xc3;moji_data[47]=0xc3;moji_data[48]=0x99;
		moji_data[49]=0x99;moji_data[50]=0xff;moji_data[51]=0xff;moji_data[52]=0x66;
		moji_data[53]=0x00;
		moji_data[54]=0x7e;moji_data[55]=0xff;moji_data[56]=0xc3;moji_data[57]=0x81;
		moji_data[58]=0x81;moji_data[59]=0xc3;moji_data[60]=0xff;moji_data[61]=0x7e;
		moji_data[62]=0x00;
	}

}

extern void	data_set(int set);

void	time_wait(long time)
{
	while(time!=0){
	time--;
	}
}

void	led_seg_out(char data)
{
	P2=(P2|0x0f)&(data&0x0f);
	P12=(P12|0x0e)&((data&0x70)>>3);
	P13=(P13|0x01)&((data&0x80)>>7);
}

void	led_port_clear(void)
{
		P4.0=1;
		P4.1=1;
		P4.2=1;
		P4.3=1;
		P4.4=1;
		P4.5=1;
		P3.0=1;
		P3.1=1;
}
void	moji_set_shift(void)
{
	switch(moji_set){
		case 0:data_set(1);break;
		case 1:data_set(2);break;
		case 2:data_set(0);break;
		case 3:data_set(4);break;
		case 4:data_set(5);break;
		case 5:data_set(3);break;
	}
}

void	data_set_ss1(void)
{
	moji_set_shift();
	disp_data[7]=moji_data[0];
	data_set(moji_set);
	disp_data[6]=moji_data[62];
	disp_data[5]=moji_data[61];
	disp_data[4]=moji_data[60];
	disp_data[3]=moji_data[59];
	disp_data[2]=moji_data[58];
	disp_data[1]=moji_data[57];
	disp_data[0]=moji_data[56];
}
void	data_set_ss2(void)
{
	moji_set_shift();
	disp_data[7]=moji_data[1];
	disp_data[6]=moji_data[0];
	data_set(moji_set);
	disp_data[5]=moji_data[62];
	disp_data[4]=moji_data[61];
	disp_data[3]=moji_data[60];
	disp_data[2]=moji_data[59];
	disp_data[1]=moji_data[58];
	disp_data[0]=moji_data[57];
}
void	data_set_ss3(void)
{
	moji_set_shift();
	disp_data[7]=moji_data[2];
	disp_data[6]=moji_data[1];
	disp_data[5]=moji_data[0];
	data_set(moji_set);
	disp_data[4]=moji_data[62];
	disp_data[3]=moji_data[61];
	disp_data[2]=moji_data[60];
	disp_data[1]=moji_data[59];
	disp_data[0]=moji_data[58];
}
void	data_set_ss4(void)
{
	moji_set_shift();
	disp_data[7]=moji_data[3];
	disp_data[6]=moji_data[2];
	disp_data[5]=moji_data[1];
	disp_data[4]=moji_data[0];
	data_set(moji_set);
	disp_data[3]=moji_data[62];
	disp_data[2]=moji_data[61];
	disp_data[1]=moji_data[60];
	disp_data[0]=moji_data[59];
}
void	data_set_ss5(void)
{
	moji_set_shift();
	disp_data[7]=moji_data[4];
	disp_data[6]=moji_data[3];
	disp_data[5]=moji_data[2];
	disp_data[4]=moji_data[1];
	disp_data[3]=moji_data[0];
	data_set(moji_set);
	disp_data[2]=moji_data[62];
	disp_data[1]=moji_data[61];
	disp_data[0]=moji_data[60];
}
void	data_set_ss6(void)
{
	moji_set_shift();
	disp_data[7]=moji_data[5];
	disp_data[6]=moji_data[4];
	disp_data[5]=moji_data[3];
	disp_data[4]=moji_data[2];
	disp_data[3]=moji_data[1];
	disp_data[2]=moji_data[0];
	data_set(moji_set);
	disp_data[1]=moji_data[62];
	disp_data[0]=moji_data[61];
}
void	data_set_ss7(void)
{
	moji_set_shift();
	disp_data[7]=moji_data[6];
	disp_data[6]=moji_data[5];
	disp_data[5]=moji_data[4];
	disp_data[4]=moji_data[3];
	disp_data[3]=moji_data[2];
	disp_data[2]=moji_data[1];
	disp_data[1]=moji_data[0];
	data_set(moji_set);
	disp_data[0]=moji_data[62];
}

void	led_disp(void)
{
	int		i;
	int		pp;

	data_set(moji_set);

	if(moji_p<56){
		for (i=0;i<=7;i++){
				pp=moji_p+i;
				disp_data[i]=moji_data[pp];
		}
	}

	switch(moji_p){
		case 56:data_set_ss1();break;
		case 57:data_set_ss2();break;
		case 58:data_set_ss3();break;
		case 59:data_set_ss4();break;
		case 60:data_set_ss5();break;
		case 61:data_set_ss6();break;
		case 62:data_set_ss7();break;
	}



	led_port_clear();
	led_seg_out(disp_data[0]);
	P3.1=0;
	time_wait(100);
	led_port_clear();
	led_seg_out(disp_data[1]);
	P3.0=0;
	time_wait(100);
	led_port_clear();
	led_seg_out(disp_data[2]);
	P4.5=0;
	time_wait(100);
	led_port_clear();
	led_seg_out(disp_data[3]);
	P4.4=0;
	time_wait(100);
	led_port_clear();
	led_seg_out(disp_data[4]);
	P4.3=0;
	time_wait(100);
	led_port_clear();
	led_seg_out(disp_data[5]);
	P4.2=0;
	time_wait(100);
	led_port_clear();
	led_seg_out(disp_data[6]);
	P4.1=0;
	time_wait(100);
	led_port_clear();
	led_seg_out(disp_data[7]);
	P4.0=0;
	time_wait(100);
	led_port_clear();
}

void	main( void )
{
int		start_key;
int		start_rep;

	moji_p=0;
	moji_set=0;

	start_key=1;
	start_rep=0;

	data_set(moji_set);

	led_port_clear();
	
	/* TODO. add user code */
	TM00_Start();
	while(1){

		if (P3.4==0){
				start_key=0;
		}
		else{
			start_key=1;
			start_rep=0;
		}


		led_disp();
	
		if ((P3.4==0)&(start_key==0)){
			start_key=0;
		}
		else{
			start_key=1;
			start_rep=0;
		}
	
		if((start_key==0)&(start_rep==0)){
			switch(moji_set){
				case 0:
				case 1:
				case 2:moji_set=3;break;
				case 3:
				case 4:
				case 5:moji_set=0;break;
			}
			data_set(moji_set);
			moji_p=0;
			start_rep=1;
		}
	
	
	
	}
}

