/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+ 8-Bit Single-Chip Microcontrollers.
**
**  Copyright(C) NEC Electronics Corporation 2002-2004
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	port.c
**  Abstract :	This file implements device driver for port module.
**  APIlib :	NEC78K0SKX1H.lib E1.46a [13 May 2005]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/

/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "port.h"
/*
*******************************************************************************
**  Constants
*******************************************************************************
*/


/*
**-----------------------------------------------------------------------------
**
**  Abstract:
**	This function initializes the I/O port module.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**-----------------------------------------------------------------------------
*/ 
void PORT_Init( void )
{
	/* Initialize the port registers */
	P2 = PORT_P2;
	P3 = PORT_P3;
	P4 = PORT_P4;
	P12 = PORT_P12;
	P13 = PORT_P13;

	/* Initialize the pull-up resistor option registers */
	PU2 = PORT_PU2;
	PU3 = PORT_PU3;
	PU4 = PORT_PU4;
	PU12 = PORT_PU12;

	/* Initialize the mode registers */
	PM2 = PORT_PM2;
	PM3 = PORT_PM3;
	PM4 = PORT_PM4;
	PM12 = PORT_PM12;

}
